# encoding: utf-8

from gi.repository import (
    Unity,
    Gio
)

class MockScope(object):

    __scope = None
    __data = None

    def __init__ (self, data):
        self.__data = data
        self.__scope = Unity.Scope.new(self.__data['dbuspath'])
        
        # Listen for changes and requests
        self.__scope.connect("search_changed", self._on_search_changed)
        self.__scope.connect("filters-changed", self._on_filters_changed)
        self.__scope.connect("activate-uri", self._activate_uri)

    def getUnityScope(self):
        return self.__scope

    def _activate_uri (self, scope, uri):
        return Unity.ActivationResponse.new (Unity.HandledType.NOT_HANDLED, uri)
            
    def _on_search_changed (self, scope, search, searchType, cancellable):
        search.props.results_model.clear()

        if (searchType == Unity.SearchType.DEFAULT):
            for entry in self.__data['data']:
                if (search.props.search_string.lower() in entry[4].lower()):
                    search.props.results_model.append(*entry)
        else:
            try:
                for entry in self.__data['global_data']:
                    if (search.props.search_string.lower() in entry[4].lower()):
                        search.props.results_model.append(*entry)
            except KeyError:
                pass
            
        search.finished()

    def _on_filters_changed(self, scope):
        pass        
